<template>
    <div class="wrapper">
        <div class="container-fuild">
            <div id="headTitle">
                <Logo />
                <h1 id="title" _msttexthash="48503" _msthash="2">Income</h1>
            </div>
            <Header />
            <ol id="topicPath">
                <li style="margin-left:249px">
                    <router-link to="income"><a href="income">
                            <font style="vertical-align: inherit">
                                <font style="vertical-align: inherit">Income</font>
                            </font>
                        </a>
                    </router-link>
                </li>
            </ol>
        </div>
        <div class="search-box">
            <div id="product">
                <div class="search-box mb-4">
                    <div class="search-box-title" id="Bars">
                        <div id="bar" style="width: 90%;">
                            <router-link to="/report"><a class="btn-radius btn btn-sm" href="#" id="bar-1">
                                    <i class="fas fa-cog"> </i>
                                    Report
                                </a>
                            </router-link>
                            <router-link to="/expensesreport"><a class="btn-radius btn btn-sm" href="#" id="bar-1">
                                    <i class="fas fa-cog"> </i>
                                    Expenses
                                </a>
                            </router-link>
                            <router-link to="/income"><a class="btn-radius btn btn-sm" href="#" id="bar-1"
                                    style="background-color: #29a5a5; border: #22adb763 1px solid;">
                                    <i class="fas fa-cog"> </i>
                                    Income
                                </a>
                            </router-link>
                            <router-link to="/labototal"><a class="btn-radius btn btn-sm" href="#" id="bar-1">
                                    <i class="fas fa-cog"> </i>
                                    Labototal
                                </a>
                            </router-link>
                            <router-link to="/expenses1"><a class="btn-radius btn btn-sm" href="#" id="bar-1">
                                    <i class="fas fa-cog"> </i>
                                    Expenses1
                                </a>
                            </router-link>
                            <router-link to="/income1"><a class="btn-radius btn btn-sm" href="#" id="bar-1">
                                    <i class="fas fa-cog"> </i>
                                    Income1
                                </a>
                            </router-link>
                        </div>
                        <div id="right" style="width: 10%;">
                            <a class="btn-radius bt-pn btn btn-sm" data-bs-toggle="dropdown" aria-expanded="false"
                                style="float: right; color: #f8f5b4;margin-top: -2px;margin-right: 11px;">
                                <i class="fas fa-plus" style="padding-right: 5px"></i>
                                Menu
                            </a>
                            <ul class="dropdown-menu">
                                <li>
                                    <a @click="getproductboom()" class="dropdown-item btn btn-primary"
                                        data-bs-toggle="modal" data-bs-target="#staticboomId" tabindex="10028">
                                        <i class="fa-solid fa-circle-b"></i> Boom Product
                                    </a>
                                </li>
                                <li>
                                    <a @click="getsuppliyerview()" class="dropdown-item btn btn-primary"
                                        data-bs-toggle="modal" data-bs-target="#staticboomId" tabindex="10028">
                                        <i class="fa fa-print" aria-hidden="true"></i>
                                        Print
                                    </a>
                                </li>
                                <li>
                                    <a class="dropdown-item" data-bs-toggle="modal" data-bs-target="#staticBackdropss"
                                        tabindex="10028" href="#">
                                        <i class="fas fa-file-excel"></i> To Excel
                                    </a>
                                </li>
                                <li>
                                    <a class="dropdown-item btn btn-primary" data-bs-toggle="modal"
                                        data-bs-target="#staticBackdropss" tabindex="10028">
                                        <i class="fas fa-edit"></i> Release
                                    </a>
                                </li>
                            </ul>
                        </div>
                    </div>
                    <div class="box">
                        <table width="100%" border="0" cellpadding="0" cellspacing="0"
                            class="table table-striped br-table">
                            <thead>
                                <tr class="header-table">
                                    <th colspan="2" style="width:35em">
                                        <input autocomplete="off" v-model="search.product_no"
                                            @change="changeSearchText(search.product_no, 'product')" type="search"
                                            class="text" style="width:100%" placeholder="ProductNo, Description" />
                                    </th>
                                    <th style="width:12em"> <input autocomplete="off" v-model="search.mos"
                                            @change="changeSearchText(search.mos, 'mos')" type="search" class="text"
                                            style="width:100%" placeholder="(>,MOS),(=,MOS),(<,MOS)" />
                                    </th>
                                    <th style="width:12em"> <input autocomplete="off" type="search" v-model="search.amc_amount"
                                            @change="changeSearchText(search.amc_amount, 'amc')" class="text"
                                            style="width:100%" placeholder="(>,AMC),(=,AMC),(<,AMC)" />
                                    </th>
                                    <th></th>
                                    <th> <input autocomplete="off" v-model="search.unit_price"
                                            @change="changeSearchText(search.unit_price, 'price')" type="search"
                                            class="text" style="width:100%" placeholder="Search" /></th>
                                    <th style="width:10em"><input autocomplete="off" v-model="search.stock_onhand"
                                            @change="changeSearchText(search.stock_onhand, 'onhand')" id="search"
                                            type="search" class="text" style="width:100%"
                                            placeholder="(>,AMC),(=,AMC),(<,AMC)" /></th>
                                    <th></th>
                                    <th>
                                        <div class="button type2" id="uniform-undefined" @click="mySearch()"><span>
                                                <input autocomplete="off" type="button" class="type2" tabindex="10025" value="display"
                                                    style="opacity: 0; width: 54px;"><i class="fa fa-search"></i>
                                                Search</span>
                                        </div>
                                        <i class="fa fa-arrow-right" aria-hidden="true" id="nxt"></i>

                                    </th>
                                </tr>
                                <tr class="header-table">
                                    <th>No</th>
                                    <th>Description</th>
                                    <th>MOS</th>
                                    <th>AMC</th>
                                    <th>AMC Amount</th>
                                    <th>Price</th>
                                    <th>Stock On Hand</th>
                                    <th>Amount</th>
                                    <th width="13%">Currency</th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr v-for="(stock, index) in allStocks" :key="index">
                                    <td width="8%">{{ index + 1 }}</td>
                                    <td width="12%">{{ stock.description }}</td>
                                    <td width="8%">{{ Number(stock.mos).toLocaleString() }}</td>
                                    <td width="10%">{{ Number(stock.amc_inventery).toLocaleString() }}</td>
                                    <td width="7%">{{ Number(stock.amc_amount).toLocaleString() }}</td>
                                    <td width="5%">{{ Number(stock.unit_price).toLocaleString() }}</td>
                                    <td width="10%">{{ Number(stock.stock_onhand).toLocaleString() }}</td>
                                    <td width="5%">{{ Number(stock.stock_aoumt).toLocaleString() }}</td>
                                    <td>{{ stock.curency_code }}</td>
                                </tr>
                            </tbody>
                        </table>
                        <div class="box-footer-pagination">
                            <ul class="pagination"><!---->
                                <li class="page-item pagination-page-nav active"><a class="page-link" href="#">1 <span
                                            class="sr-only">(current)</span></a></li>
                                <li class="page-item pagination-page-nav"><a class="page-link" href="#">2 <!----></a>
                                </li>
                                <li class="page-item pagination-next-nav"><a class="page-link" href="#"
                                        aria-label="Next" tabindex="false"><span aria-hidden="true">»</span><span
                                            class="sr-only">Next</span></a></li>
                            </ul>
                        </div>
                    </div>
                    <div class="box-footer-pagination">
                        <pagination :limit="2" :data="allStocks" @pagination-change-page="getStock" />
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="modal fade ui-modal" id="staticboomId" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1"
        aria-labelledby="staticboomId" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content ui-dialog">
                <div class="ui-widget-header">
                    <h5 class="modal-title in-header" id="staticBackdropLabel"><i class="fa fa-print"
                            aria-hidden="true"></i>
                        Print</h5>
                    <span class="ui-icon ui-icon-closethick" data-bs-dismiss="modal" aria-label="Close"></span>
                </div>
                <div class="ui-dialog-content" id="purchaseorder">
                    <div class="card">
                        <div class="card-body">
                            <div class="mt-3 print-size">

                                <div style="padding:0 50px 0 50px; background-color: #fff;">
                                    <div class="col-md-12">
                                        <div class="text-center">
                                            <h3 class="title-purchase">REPORT</h3>
                                        </div>
                                    </div>
                                    <div class="col-container">
                                        <div class="col1" style="width: 55%;">
                                            <p class=" p-bg font-size p-pad">COMPANY NAME</p>
                                            <p class="p-mg info-pad"><span id="bold">Name :</span> <span id="fon">{{ company.company_name }}</span></p>
                                            <p class="p-mg  info-pad"><span id="bold">Phone Number :</span> <span id="fon">{{ company.company_Phone }}</span></p>
                                            <p class="p-mg info-pad"><span id="bold">Email Address :</span> <span id="fon">{{ company.company_Email }}</span></p>
                                            <p class="p-mg info-pad"><span id="bold">Address :</span> <span id="fon">{{ company.company_Address }}</span></p>
                                        </div>
                                        <div class="col2">
                                            <p class="text-center p-bg font-size p-pad">DATE</p>
                                            <p class="text-center p-mg" id="fon">{{ dateformart }}</p>
                                            <p class="text-center p-bg font-size p-pad">REPORT NO.</p>
                                            <p class="text-center p-mg" id="fon">{{ count }}</p>
                                        </div>
                                    </div>
                                    <div class=" my-2  justify-content-center">
                                        <table id="pr-tb">
                                            <thead>
                                                <tr class="p-bg">
                                                    <th>No</th>
                                                    <th>Description</th>
                                                    <th>MOS</th>
                                                    <th>AMC</th>
                                                    <th>AMC_Amount</th>
                                                    <th>Price</th>
                                                    <th>Curency</th>
                                                    <th>On Hand</th>
                                                    <th>Amount</th>
                                                </tr>
                                            </thead>
                                            <tbody>
                                                <tr v-for="(stock, index) in allStocks" :key="index">
                                                    <td width="8%">{{ stock.product_no }}</td>
                                                    <td width="12%">{{ stock.description }}</td>
                                                    <td width="8%">{{ Number(stock.mos).toLocaleString() }}</td>
                                                    <td width="10%">{{ Number(stock.amc_inventery).toLocaleString() }}
                                                    </td>
                                                    <td width="5%">{{ Number(stock.amc_amount).toLocaleString() }}</td>
                                                    <td width="5%">{{ Number(stock.unit_price).toLocaleString() }}</td>
                                                    <td width="6%">{{ stock.curency_code }}</td>
                                                    <td width="10%">{{ Number(stock.stock_onhand).toLocaleString() }}
                                                    </td>
                                                    <td width="5%">{{ Number(stock.stock_aoumt).toLocaleString() }}</td>
                                                </tr>
                                            </tbody>
                                        </table>
                                    </div>
                                    <hr>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <a v-print="'#purchaseorder'" class="btn-purchase btn-light text-capitalize border-0"
                        data-mdb-ripple-color="dark"><i class="fas fa-print text-primary"></i> Print</a>
                </div>
            </div>
        </div>
    </div>
    <Footer />
</template>

<script>
    import axios from "axios";
    import { useCurrentTime } from "../../componentJS/date";
    import pagination from "laravel-vue-pagination";
    import moment from "moment";
    import Logo from "../logo.vue"
    import Header from "../Header.vue";
    import Footer from "../footer.vue";
    import print from 'vue3-print-nb';
    export default {
        components: { pagination, Header, Footer, Logo },
        directives: { print },
        setup() {
            const { currentTime } = useCurrentTime();
            return { currentTime };
        },

        data() {
            return {
                Categories: [],
                links: [],
                company: [],
                perPage: "",
                currentPage: 0,
                last_page: 1,
                action_api: "",
                action_api_1: "",
                formatdate: "",
                isDisabled: false,
                stockcount: 0,
                form: {
                    id: "",
                    cat_code: "",
                    cat_name: "",
                    cat_name_2: "",
                    inactived: "",
                    created_by: "",
                    updete_by: "",
                },
                forms_clear: {
                    id: "",
                    cat_code: "",
                    cat_name: "",
                    cat_name_2: "",
                    inactived: "",
                    created_by: "",
                    updete_by: "",
                },
                allStocks: [],
                count: 0,
                search: '',
                mos: null,
                search_AMC: null,
                unit_price: null,
                search: {
                    product_no: '',
                    mos: '',
                    amc_amount: '',
                    unit_price: '',
                    stock_onhand: ''
                },
                count_expire: 0,
            };
        },
        mounted() {
            this.getCategorys();
            this.getcompany();
            this.getStock();
            this.getstockalert()
            this.getExpire()
        },
        methods: {
            async getCategorys() {
                await axios.get("/api/v1/stocktraview").then((res) => {
                    this.Categories = res.data;
                });
            },
            async getcompany() {
                await axios.get("/api/v1/getSetup/")
                    .then((response) => {
                        this.company = response.data;
                        this.dateformart = moment(new Date()).format('YYYY-MM-DD');
                    });
            },
            async getStock(page = 1) {
                await axios.get("api/v1/soh/getIndex?page=" + page)
                    .then(({ data }) => {
                        this.allStocks = data.data
                        this.count = this.allStocks.length
                    })
            },
            getstockalert() {
                axios.get("api/v1/stockcheck/checkOptionstock").then((response) => {
                    this.stockcount = response.data.length;
                });
            },
            searchProductNo(x) {
                axios.get('api/v1/soh/index', { search: this.search })
                    .then(res => {
                        this.allStocks = res.data
                    })
            },
            changeSearchText(value, label) {
                if (label == 'product') {
                    this.search = {
                        product_no: value,
                        mos: '',
                        amc_amount: '',
                        unit_price: '',
                        stock_onhand: ''
                    }
                }
                else if (label == 'mos') {
                    this.search = {
                        product_no: '',
                        mos: value,
                        amc_amount: '',
                        unit_price: '',
                        stock_onhand: ''
                    }
                }
                else if (label == 'amc') {
                    this.search = {
                        product_no: '',
                        mos: '',
                        amc_amount: value,
                        unit_price: '',
                        stock_onhand: ''
                    }
                }
                else if (label == 'price') {
                    this.search = {
                        product_no: '',
                        mos: '',
                        amc_amount: '',
                        unit_price: value,
                        stock_onhand: ''
                    }
                }
                else if (label == 'onhand') {
                    this.search = {
                        product_no: '',
                        mos: '',
                        amc_amount: '',
                        unit_price: '',
                        stock_onhand: value
                    }
                }
                else {
                    this.search = {
                        product_no: '',
                        mos: '',
                        amc_amount: '',
                        unit_price: '',
                        stock_onhand: ''
                    }
                }
            },
            mySearch() {
                axios.post('api/v1/soh/index', this.search)
                    .then(({ data }) => {
                        this.allStocks = data.data

                    })
            },
            getExpire() {
                axios.get('api/v1/expireAlert')
                    .then((res) => {
                        this.count_expire = res.data.length
                    })
            }
        },
    };
</script>
